----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    23:46:55 02/14/2022 
-- Design Name: 
-- Module Name:    detect - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;


entity detect is
    Port ( clk_in : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           sign_in : in  STD_LOGIC_VECTOR (15 downto 0);
           sign_len : in  STD_LOGIC_VECTOR (1 downto 0);
           samples_addr : out  STD_LOGIC_VECTOR (18 downto 0);
           lvl_out : out  STD_LOGIC_VECTOR (47 downto 0);
			  done_detect : out  STD_LOGIC);
end detect;

architecture Behavioral of detect is

	signal acc: std_logic_vector (47 downto 0);
	signal sample_square: std_logic_vector (31 downto 0);
	signal cnt: unsigned (18 downto 0);
	signal samples_max: unsigned (9 downto 0);

begin

with sign_len select
	samples_max <= "0001001111" when "11",
						"0001001111" when "10",
						"0001001111" when "01",
						"0001001111" when others;



process_detect: process (clk_in) is
begin

	-- all in sync with 100MHz clock
	if (clk_in'event and clk_in = '1') then
		-- reset
		if (reset = '1') then
			acc <= (others => '0');
			sample_square <= (others => '0');
			cnt <= (others => '0');
			done_detect <= '0';
		-- 
--		elsif (cnt < samples_max) then
--			sample_square <= sign_in * sign_in;
--			acc <= acc + sample_square;
--			cnt <= cnt + 1;
--		else
--			done_detect <= '1';
			
			
		elsif (cnt < samples_max) then
			sample_square <= sign_in * sign_in;
			acc <= acc + sample_square;
			cnt <= cnt + 1;
		else
			done_detect <= '1';
		end if;
	end if;
end process process_detect;

lvl_out <= acc;
samples_addr <= std_logic_vector(cnt);

end Behavioral;
