----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    18:12:02 01/31/2022 
-- Design Name: 
-- Module Name:    top - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity top is
    Port ( clk : in STD_LOGIC;
			  adc_in : in STD_LOGIC_VECTOR (11 downto 0);
           adc_clk : out STD_LOGIC;
           sram_oe : out STD_LOGIC;
           sram_we : out STD_LOGIC;
           sram_data : inout STD_LOGIC_VECTOR (15 downto 0);
           sram_addr : out STD_LOGIC_VECTOR (17 downto 0);
           sram_cs_0 : out STD_LOGIC;
           sram_cs_1 : out STD_LOGIC;
           uc_data : inout STD_LOGIC_VECTOR (7 downto 0);
           uc_dclk : in STD_LOGIC;
           uc_rd : out STD_LOGIC;
           uc_wr : in STD_LOGIC;
           uc_dir : in STD_LOGIC;
           uc_clk : out STD_LOGIC;
			  dbg_out : out STD_LOGIC_VECTOR (3 downto 0);			  
			  graph_uc_data : in STD_LOGIC_VECTOR(9 downto 0);
			  graph_uc_clk : in STD_LOGIC;    
			  graph_sram_data : inout STD_LOGIC_VECTOR(15 downto 0);
			  graph_sram_addr : out STD_LOGIC_VECTOR(17 downto 0);
			  graph_sram_cs : out STD_LOGIC;
			  graph_sram_lb : out STD_LOGIC;
			  graph_sram_ub : out STD_LOGIC;
			  graph_sram_oe : out STD_LOGIC;
			  graph_sram_we : out STD_LOGIC;
			  tft_data : out STD_LOGIC_VECTOR(8 downto 0);
			  tft_vs : out STD_LOGIC;
			  tft_hs : out STD_LOGIC;
			  tft_de : out STD_LOGIC;
			  tft_clk : out STD_LOGIC
			  );
end top;

architecture Behavioral of top is


signal sram_data_wr, sram_data_rd, sram_data_rw: std_logic_vector (15 downto 0);
signal graph_sram_data_wr, graph_sram_data_rd, graph_sram_data_rw: std_logic_vector (15 downto 0);

signal uc_data_out, uc_data_dir, uc_data_in: std_logic_vector (7 downto 0);
signal sign_in_sel: std_logic;
signal sign_dsp_out: std_logic_vector (15 downto 0);
signal dsp_reset: std_logic;
signal sign_len: std_logic_vector (1 downto 0);
signal sram_rw_dsp_out, sram_oe_dsp_out, sram_oe_ctrl_out, sram_rw_ctrl_out: std_logic;
signal done_dsp, done_detect: std_logic;
signal samples_addr_dsp, samples_addr_ctrl, samples_addr_detect: std_logic_vector (18 downto 0);
signal detect_reset: std_logic;
signal lvl: std_logic_vector (47 downto 0);
signal conf: std_logic_vector (15 downto 0);
signal clk100M: std_logic := '0';
signal clk50M: std_logic := '0';
signal addr_sel: std_logic_vector (1 downto 0);
signal sram_we_sig: std_logic;
signal ctrl_int: std_logic;

		signal dbg_i_adc_sig:integer:=0;
		signal dbg_adc_in: std_logic_vector (11 downto 0);
		signal asdf_adc_clk: std_logic;
		type testsign_t is array (0 to 563) of std_logic_vector(11 downto 0);
		signal testsign : testsign_t := (
"000000000000","010100101110","001101101011","111101110100","111010110011","111000011001","110010010010","111100011100","010001001100","010000000011","111011010011","110100101101","111101111010","111110100100","111011001001","000100101101",
"001011110011","111111100101","110110000000","000000100100","000111100111","111100000110","110110011111","000010001010","000111011001","000000000000","000001001010","000111100010","111101000000","101110011011","111000011001","001101001010",
"001101101110","000010000110","111111001010","111011010011","101111110111","110100011000","001101000110","010110110101","000100101101","110101010100","110110111110","110111111010","111000010011","000111100111","010101010110","000111110110",
"110001111010","110011001101","000000000000","000000101110","000000011001","001001110110","001001000001","111000011001","110100010100","000010110111","000110101011","111011001101","111011010011","000110110111","000101011001","111100000101",
"111111110101","000100101101","111001010001","110010011000","000010110001","010001001001","000111100111","111010110000","111011000000","111001000100","110011101001","000000000000","010100111010","010000101001","111000100000","101111110001",
"111000011001","111100100101","000000111101","001111010011","010001101100","111011010011","101011001011","110110110111","000101100111","000100101011","000100101101","001010001010","000001011110","110001100000","110110010001","000111100111",
"000111001000","111011110100","111111001101","000111001101","000000000000","111000110011","000000110011","000100001100","111000111000","111000011001","001001101111","001110100000","111110100010","110101110110","111011010011","111011010101",
"111010011001","001001001001","010100110101","000100101101","101110010100","110000101101","111111000011","000011011011","000111100111","010000001111","000111100000","101111010111","101011000110","000000000000","001100010111","000110111100",
"000101000000","000101010000","111000011001","101110110111","111101001111","001101101000","000110101111","111011010011","000000001011","000011111011","111010100111","111001001001","000100101101","000100110011","111001010101","111101001001",
"001011101100","000111100111","110110111111","110110001010","111111100111","111111010010","000000000000","001100110011","001110000110","111000001010","101010101010","111000011001","000111101101","001000000110","001001000010","001010101100",
"111011010011","101001001011","110010111010","001011101000","010000001001","000100101101","000000110110","111101111010","110010010010","110010110110","000111100111","010001100101","000011000000","111000011110","111110110110","000000000000",
"111000100111","111101110110","001001100001","000011111010","111000011001","111111011100","001010000000","000000011011","110100001101","111011010011","000100110111","000001011100","000010000110","001011010011","000100101101","101111111101",
"101110110100","000011100100","001101101110","000111100111","000101001101","000010001100","110010010101","101011010010","000000000000","010100101110","001101101011","111101110100","111010110011","111000011001","110010010010","111100011100",
"010001001100","010000000011","111011010011","110100101101","111101111010","111110100100","111011001001","000100101101","001011110011","111111100101","110110000000","000000100100","000111100111","111100000110","110110011111","000010001010",
"000111011001","000000000000","000001001010","000111100010","111101000000","101110011011","111000011001","001101001010","001101101110","000010000110","111111001010","111011010011","101111110111","110100011000","001101000110","010110110101",
"000100101101","110101010100","110110111110","110111111010","111000010011","000111100111","010101010110","000111110110","110001111010","110011001101","000000000000","000000101110","000000011001","001001110110","001001000001","111000011001",
"110100010100","000010110111","000110101011","111011001101","111011010011","000110110111","000101011001","111100000101","111111110101","000100101101","111001010001","110010011000","000010110001","010001001001","000111100111","111010110000",
"111011000000","111001000100","110011101001","000000000000","010100111010","010000101001","111000100000","101111110001","111000011001","111100100101","000000111101","001111010011","010001101100","111011010011","101011001011","110110110111",
"000101100111","000100101011","000100101101","001010001010","000001011110","110001100000","110110010001","000111100111","000111001000","111011110100","111111001101","000111001101","000000000000","111000110011","000000110011","000100001100",
"111000111000","111000011001","001001101111","001110100000","111110100010","110101110110","111011010011","111011010101","111010011001","001001001001","010100110101","000100101101","101110010100","110000101101","111111000011","000011011011",
"000111100111","010000001111","000111100000","101111010111","101011000110","000000000000","001100010111","000110111100","000101000000","000101010000","111000011001","101110110111","111101001111","001101101000","000110101111","111011010011",
"000000001011","000011111011","111010100111","111001001001","000100101101","000100110011","111001010101","111101001001","001011101100","000111100111","110110111111","110110001010","111111100111","111111010010","000000000000","001100110011",
"001110000110","111000001010","101010101010","111000011001","000111101101","001000000110","001001000010","001010101100","111011010011","101001001011","110010111010","001011101000","010000001001","000100101101","000000110110","111101111010",
"110010010010","110010110110","000111100111","010001100101","000011000000","111000011110","111110110110","000000000000","111000100111","111101110110","001001100001","000011111010","111000011001","111111011100","001010000000","000000011011",
"110100001101","111011010011","000100110111","000001011100","000010000110","001011010011","000100101101","101111111101","101110110100","000011100100","001101101110","000111100111","000101001101","000010001100","110010010101","101011010010",
"000000000000","010100101110","001101101011","111101110100","111010110011","111000011001","110010010010","111100011100","010001001100","010000000011","111011010011","110100101101","111101111010","111110100100","111011001001","000100101101",
"001011110011","111111100101","110110000000","000000100100","000111100111","111100000110","110110011111","000010001010","000111011001","000000000000","000001001010","000111100010","111101000000","101110011011","111000011001","001101001010",
"001101101110","000010000110","111111001010","111011010011","101111110111","110100011000","001101000110","010110110101","000100101101","110101010100","110110111110","110111111010","111000010011","000111100111","010101010110","000111110110",
"110001111010","110011001101","000000000000","000000101110","000000011001","001001110110","001001000001","111000011001","110100010100","000010110111","000110101011","111011001101","111011010011","000110110111","000101011001","111100000101",
"111111110101","000100101101","111001010001","110010011000","000010110001","010001001001","000111100111","111010110000","111011000000","111001000100","110011101001","000000000000","010100111010","010000101001","111000100000","101111110001",
"111000011001","111100100101","000000111101","001111010011","010001101100","111011010011","101011001011","110110110111","000101100111","000100101011","000100101101","001010001010","000001011110","110001100000","110110010001","000111100111",
"000111001000","111011110100","111111001101","000111001101","000000000000","111000110011","000000110011","000100001100","111000111000","111000011001","001001101111","001110100000","111110100010","110101110110","111011010011","111011010101",
"111010011001","001001001001","010100110101","000100101101","101110010100","110000101101","111111000011","000011011011","000111100111","010000001111","000111100000","101111010111","101011000110","000000000000","001100010111","000110111100",
"000101000000","000101010000","111000011001","101110110111","111101001111","001101101000","000110101111","111011010011","000000001011","000011111011","111010100111","111001001001","000100101101","000100110011","111001010101","111101001001",
"001011101100","000111100111","110110111111","110110001010","111111100111","111111010010","000000000000","001100110011","001110000110","111000001010","101010101010","111000011001","000111101101","001000000110","001001000010","001010101100",
"111011010011","101001001011","110010111010","001011101000");

COMPONENT IOBUF
PORT(
	I: IN std_logic;
	T: IN std_logic;
	O: OUT std_logic;
	IO: INOUT std_logic);
END COMPONENT;

COMPONENT dsp
PORT(
	sign_in : IN std_logic_vector(15 downto 0);
	clk_in : IN std_logic;
	reset : IN std_logic;
	sign_len : IN std_logic_vector(1 downto 0);          
	sign_out : OUT std_logic_vector(15 downto 0);
	samples_addr : OUT std_logic_vector(18 downto 0);
	sram_rw : OUT std_logic;
	sram_oe : OUT std_logic;
	done_dsp : OUT std_logic);
END COMPONENT;

COMPONENT ctrl
PORT(
	conf_in : IN std_logic_vector(15 downto 0);
	clk_in : IN std_logic;
	clk_record_in : IN std_logic;
	done_dsp : IN std_logic;          
	done_detect : IN std_logic;
	dbg_out : OUT std_logic_vector(3 downto 0);
	sign_len : OUT std_logic_vector(1 downto 0);      
	detect_reset : OUT std_logic;
	sram_oe : OUT std_logic;
	sram_rw : OUT std_logic;
	samples_addr : OUT std_logic_vector(18 downto 0);
	dsp_reset : OUT std_logic;
	addr_sel : OUT std_logic_vector(1 downto 0);
	sign_in_sel : OUT std_logic;
	adc_clk : OUT std_logic;
	ctrl_int : OUT std_logic);
END COMPONENT;

COMPONENT detect
PORT(
	clk_in : IN std_logic;
	reset : IN std_logic;
	sign_in : IN std_logic_vector(15 downto 0);      
	sign_len : IN std_logic_vector(1 downto 0);       
	samples_addr : OUT std_logic_vector(18 downto 0);
	lvl_out : OUT std_logic_vector(47 downto 0);
	done_detect : OUT std_logic);
END COMPONENT;

COMPONENT uc_interface
PORT(
	clk_in : IN std_logic;
	lvl_in : IN std_logic_vector(47 downto 0);     
	conf_out : OUT std_logic_vector(15 downto 0);
   ctrl_int : IN std_logic;
	uc_dclk : IN std_logic;
	uc_rd : OUT std_logic;
	uc_wr : IN std_logic;
   uc_dir : IN std_logic;
	uc_data_in : IN std_logic_vector(7 downto 0);    
	uc_data_out : OUT std_logic_vector(7 downto 0));
END COMPONENT;

COMPONENT graphics
PORT(
	clk_in : IN std_logic;
	graph_uc_data : IN std_logic_vector(9 downto 0);
	graph_uc_clk : IN std_logic;    
	graph_sram_addr : OUT std_logic_vector(17 downto 0);
	graph_sram_cs : OUT std_logic;
	graph_sram_lb : OUT std_logic;
	graph_sram_ub : OUT std_logic;
	graph_sram_oe : OUT std_logic;
	graph_sram_we : OUT std_logic;
	graph_sram_data_rd : IN std_logic_vector(15 downto 0);  
	graph_sram_data_wr : OUT std_logic_vector(15 downto 0);
	graph_sram_data_rw : OUT std_logic_vector(15 downto 0);
	tft_data : OUT std_logic_vector(8 downto 0);
	tft_vs : OUT std_logic;
	tft_hs : OUT std_logic;
	tft_de : OUT std_logic;
	tft_clk : OUT std_logic
	);
END COMPONENT;


begin

GEN_SRAM_DATA_IO: for i_sram in 0 to 15 generate
	Inst_IOBUF: IOBUF port map (I => sram_data_wr(i_sram), T => sram_data_rw(i_sram), O => sram_data_rd(i_sram), IO => sram_data(i_sram));
end generate GEN_SRAM_DATA_IO;

GEN_GRAPH_SRAM_DATA_IO: for i_graph_sram in 0 to 15 generate
	Inst_IOBUF: IOBUF port map (I => graph_sram_data_wr(i_graph_sram), T => graph_sram_data_rw(i_graph_sram), O => graph_sram_data_rd(i_graph_sram), IO => graph_sram_data(i_graph_sram));
end generate GEN_GRAPH_SRAM_DATA_IO;

GEN_UC_DATA_IO: for i_uc in 0 to 7 generate
	Inst_IOBUF: IOBUF port map (I => uc_data_out(i_uc), T => uc_data_dir(i_uc), O => uc_data_in(i_uc), IO => uc_data(i_uc));
end generate GEN_UC_DATA_IO;

Inst_dsp: dsp PORT MAP(
	sign_in => sram_data_rd,
	sign_out => sign_dsp_out,
	clk_in => clk50M,
	reset => dsp_reset,
	sign_len => sign_len,
	samples_addr => samples_addr_dsp,
	sram_rw => sram_rw_dsp_out,
	sram_oe => sram_oe_dsp_out,
	done_dsp => done_dsp);

Inst_ctrl: ctrl PORT MAP(
	conf_in => conf,
	clk_in => clk50M,
	clk_record_in => clk100M,
	done_dsp => done_dsp,
	done_detect => done_detect,
	dbg_out => dbg_out,
	sign_len => sign_len,
	detect_reset => detect_reset,
	sram_oe => sram_oe_ctrl_out,
	sram_rw => sram_rw_ctrl_out,
	samples_addr => samples_addr_ctrl,
	dsp_reset => dsp_reset,
	addr_sel => addr_sel,
	sign_in_sel => sign_in_sel,
	adc_clk => asdf_adc_clk,
	ctrl_int => ctrl_int);

Inst_detect: detect PORT MAP(
	clk_in => clk50M,
	reset => detect_reset,
	sign_in => sram_data_rd,
	sign_len => sign_len,   
	samples_addr => samples_addr_detect,
	lvl_out => lvl,
	done_detect => done_detect);

Inst_uc_interface: uc_interface PORT MAP(
	clk_in => clk50M,
	lvl_in => lvl,
	conf_out => conf,
	ctrl_int => ctrl_int,
	uc_dclk => uc_dclk,
	uc_rd => uc_rd,
	uc_wr => uc_wr,
	uc_dir => uc_dir,
	uc_data_in => uc_data_in,
	uc_data_out => uc_data_out);

Inst_graphics: graphics PORT MAP(
	clk_in => clk100M,	--TODO!!!!!!! too slow, use dcm
	graph_uc_data => graph_uc_data,
	graph_uc_clk => graph_uc_clk,
	graph_sram_addr => graph_sram_addr,
	graph_sram_cs => graph_sram_cs,
	graph_sram_lb => graph_sram_lb,
	graph_sram_ub => graph_sram_ub,
	graph_sram_oe => graph_sram_oe,
	graph_sram_we => graph_sram_we,
	graph_sram_data_rd => graph_sram_data_rd,
	graph_sram_data_wr => graph_sram_data_wr,
	graph_sram_data_rw => graph_sram_data_rw,
	tft_data => tft_data,
	tft_vs => tft_vs,
	tft_hs => tft_hs,
	tft_de => tft_de,
	tft_clk => tft_clk
);


sram_oe <= sram_oe_dsp_out OR sram_oe_ctrl_out;
sram_we_sig <= sram_rw_dsp_out AND sram_rw_ctrl_out;
sram_we <= sram_we_sig;
sram_data_rw <= 	"1111111111111111" when (sram_we_sig = '1') else
						"0000000000000000";

sram_data_wr <=	adc_in & "0000" when (sign_in_sel = '0') else
						--dbg_adc_in(11) & dbg_adc_in(11) & dbg_adc_in(11) & dbg_adc_in & "0" when (sign_in_sel = '0') else
						sign_dsp_out;
						
sram_addr <= 		samples_addr_ctrl (17 downto 0) when addr_sel = "00" else
						samples_addr_dsp (17 downto 0)  when addr_sel = "01" else
						samples_addr_detect (17 downto 0);
sram_cs_0 <= 		samples_addr_ctrl (18) when addr_sel = "00" else
						samples_addr_dsp (18)  when addr_sel = "01" else
						samples_addr_detect (18);
sram_cs_1 <= 		NOT samples_addr_ctrl (18) when addr_sel = "00" else
						NOT samples_addr_dsp (18)  when addr_sel = "01" else
						NOT samples_addr_detect (18);

uc_data_dir <= 	"11111111" when (uc_dir = '1') else
						"00000000";

uc_clk <= clk50M;

process_clk_div: process (clk) is
begin
	if (clk'event and clk = '1') then
		clk100M <= NOT clk100M;
	end if;
end process process_clk_div;
					
process_clk_div_uc: process (clk100M) is
begin
	if (clk100M'event and clk100M = '1') then
		clk50M <= NOT clk50M;
	end if;
end process process_clk_div_uc;


--below for debug purpose (to be removed)
	adc_clk <= asdf_adc_clk;
	dbg_sign_in_proc: process(asdf_adc_clk) is
	begin
		if(asdf_adc_clk'event and asdf_adc_clk = '1') then
			if(dbg_i_adc_sig < 564) then
				dbg_i_adc_sig <= dbg_i_adc_sig + 1;
				dbg_adc_in <= testsign(dbg_i_adc_sig);
			else
				dbg_i_adc_sig <= 0;
			end if;
		end if;
   end process;
	

end Behavioral;

