----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    23:51:30 02/14/2022 
-- Design Name: 
-- Module Name:    uc_interface - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity uc_interface is
    Port ( clk_in : in  STD_LOGIC;
           lvl_in : in  STD_LOGIC_VECTOR (47 downto 0);
           conf_out : out  STD_LOGIC_VECTOR (15 downto 0);
           ctrl_int : in  STD_LOGIC;
           uc_dclk : in  STD_LOGIC;
           uc_rd : out  STD_LOGIC;
           uc_wr : in  STD_LOGIC;
			  uc_dir : in  STD_LOGIC;
           uc_data_in : in  STD_LOGIC_VECTOR (7 downto 0);
           uc_data_out : out  STD_LOGIC_VECTOR (7 downto 0));
end uc_interface;

architecture Behavioral of uc_interface is
	signal conf_sig: std_logic_vector (15 downto 0);
	signal last_uc_wr: std_logic;
	signal uc_wr_sync: std_logic;
	signal lvl_sig: std_logic_vector (47 downto 0);
begin


process_uc_receive: process (uc_dclk) is
begin
	if(uc_dclk'event and uc_dclk = '1') then
		conf_sig(15 downto 8) <= conf_sig(7 downto 0);
		conf_sig(7 downto 0) <= uc_data_in;
	end if;
end process process_uc_receive;

process_uc_receive_latch: process (clk_in) is
begin
	if(clk_in'event and clk_in = '1') then
		if(uc_wr_sync = '1' and last_uc_wr = '0') then
			conf_out <= conf_sig;
		end if;
		uc_wr_sync <= uc_wr;
		last_uc_wr <= uc_wr_sync;
	end if;
end process process_uc_receive_latch;

process_uc_send: process (uc_dclk) is
begin
	if(uc_dclk'event and uc_dclk = '1') then
		if(uc_dir = '0') then
			uc_data_out <= lvl_sig(47 downto 40);
		   lvl_sig(47 downto 40) <= lvl_sig(39 downto 32);
		   lvl_sig(39 downto 32) <= lvl_sig(31 downto 24);
		   lvl_sig(31 downto 24) <= lvl_sig(23 downto 16);
		   lvl_sig(23 downto 16) <= lvl_sig(15 downto 8);
		   lvl_sig(15 downto 8) <= lvl_sig(7 downto 0);
		else
			lvl_sig <= lvl_in;
		end if;
	end if;
end process process_uc_send;

uc_rd <= ctrl_int;
           
end Behavioral;

