clear all
close all
file_id = fopen('input_samples.txt', 'w');
pkg load signal

#prepare test signal
sampling_freq = 20e6;
sampl_n = 5209;
t = [0: 1/sampling_freq: sampl_n/sampling_freq];
u = 512 * (sin(2 * pi * 2.6e6 * t) + sin(2 * pi * 3.0e6 * t) + sin(2 * pi * 3.05e6 * t));  #maximum (or minimum) of the test signal should be below 2^11
#u_d = dec2bin(typecast(int16(u),'uint16'))
fprintf(file_id, "%i\n", round(u))

#analyze results
#insert data from simulation (DSP block output) below:
result = dlmread("output_results.txt");
result_odd = result(1:2:end);          % Odd-Indexed Elements
result_even = result(2:2:end);         % Even-Indexed Elements
result_abs = (result_odd.^2 + result_even.^2).^0.5;
figure(1);
plot(u);
figure(2);
#plot(abs(fft(u)));
plot(20*log10(abs(fftshift(fft(u.*flattopwin(length(u)).'))/length(u))));

figure(3); hold on;
plot(result_odd);
plot(result_even); hold off;

figure(4); hold on;
plot(abs(fft(result_odd)));
plot(abs(fft(result_even))); hold off;
#plot(20*log10(abs(fftshift(fft(result_odd.*flattopwin(length(result_odd)).'))/length(result_odd))));
#plot(20*log10(abs(fftshift(fft(result_even.*flattopwin(length(result_even)).'))/length(result_even))));

#sum of squares - should be equal to detector block output
acc = 0;
for asdf = [1: 1: length(result)]
  acc = acc + result(asdf) ^ 2;
endfor;
acc

fclose(file_id);
