#include <xc.h>
#include <math.h>
#include "global.h"
#include "pll.h"
#include "graph.h"
#include "lvl_lo1.h"
#include "atten.h"

#define REC_LEN 3000
#define MEAS_OFFS 100

void measure(void); //function which makes measurement from start to stop frequency
void start_meas(int filt_stages);   //ask fpga to measure
int64_t get_meas(void); //receive data from fpga
float scale_equalize(double meas_db, double freq);  //processing of the measured value
void gain_corr_point(float *meas_result, int n_points); //calibration at one frequency point
void gain_corr_clr(void);   //clear amplitude calibration coefficients
void gain_corr_apply(void); //fill the whole calibration coefficients array by interpolating the calibrated frequency points
