#ifndef _GLOBAL
#define _GLOBAL

#define FREF 12500000
#define FVCO1_START 2000000000.0
#define FVCO1_STOP  2500000000.0
#define FVCO2_START 2500000000.0
#define FVCO2_STOP  3000000000.0
#define FVCO3_START 3000000000.0
#define FVCO3_STOP  3500000000.0
#define FREQ_IF1 4000000000
#define FREQ_IN_MIN 0
#define FREQ_IN_MAX 3000000000.0

#define LVL_CORR_POINTS 100
#define GAIN_CORR_POINTS 100
#define CAL_LVL_DBM -10

#define PIN_KEYB_LATCH LATBbits.LATB8
#define PIN_KEYB_SEL0 LATBbits.LATB13
#define PIN_KEYB_SEL1 LATBbits.LATB14
#define PIN_KEYB_CLK LATBbits.LATB9
#define PIN_KEYB_DATA PORTBbits.RB12


struct meas_config_struct
{
    int atten;  //attenuation value (for configufin input attenuator)
    double ref_lvl; //reference level for display
    double scale;   //dB per division
    double f_start; //start of sweep frequency
    double f_stop;  //end of sweep frequency
    int rbw_sel;    //number that specifies resolution bandwidth filter (0/1/2/3 corresponds to 1MHz/100kHz/10kHz/1kHz)
    int if_gain;    //configuration of hardware IF amplifier gain
};

struct cal_struct
{
    int lo1_lvl_corr[LVL_CORR_POINTS];  //calibration coefficients for LO1 level control
    float gain_corr[GAIN_CORR_POINTS][4];   //amplitude calibration - points in frequency (for uneven losses of 1st mixer) * points in amplitude (for inaccuracy of input attenuator - 0/10/20/30dB are calibrated)
    double f_cal;   //frequency calibration (offset)
    int n_first_cal;    //flag that is set after first initialization of calibration data in nonvolatile memory
};

#endif
