#include "lvl_lo1.h"
#include "flash.h"

extern struct cal_struct cal;

void lvl_lo1_set(int lo1_lvl_val)
{
    I2C2CONbits.SEN = 1;
    while (I2C2CONbits.SEN);
    I2C2TRN = 0x60<<1;          //send address 0x60 (7 bits, align left)
    while (I2C2STATbits.TRSTAT);
    I2C2TRN = 0x00;             //send DAC data
    while (I2C2STATbits.TRSTAT);
    I2C2TRN = lo1_lvl_val;      //send DAC data (level)
    while (I2C2STATbits.TRSTAT);
    I2C2CONbits.PEN = 1;
    while (I2C2CONbits.PEN == 1);
}


void lvl_lo1_cal(void)
{
    int i_lvl;
    double freq;
    int lo1_lvl_val = 0x01;
    int lo1_lvl_meas;
    
    for(i_lvl = 0; i_lvl < LVL_CORR_POINTS; ++i_lvl)
    {
        lo1_lvl_meas = 0;
        freq = FVCO1_START + i_lvl * (FVCO3_STOP - FVCO1_START) / (double)(LVL_CORR_POINTS - 1);
        pll_lo1_set(freq);
        for(; lo1_lvl_val < 0xFF && lo1_lvl_val > 0x00 && (lo1_lvl_meas < LO1_LVL_REF_L || lo1_lvl_meas > LO1_LVL_REF_H);
            lo1_lvl_meas < LO1_LVL_REF_L ? ++lo1_lvl_val : --lo1_lvl_val)
        {
            lvl_lo1_set(lo1_lvl_val);
            for(int32_t i_delay = 10000; --i_delay; i_delay > 0);
            AD1CON1bits.SAMP = 0;       // Clearing SAMP bit ends sampling and starts conversion
            while(!(AD1CON1bits.DONE)); // conversion done?
            lo1_lvl_meas = ADC1BUF0;
        }
        cal.lo1_lvl_corr[i_lvl] = lo1_lvl_val;
    }
}